/* MARCHE PRESQUE
jit.phys.multiple + jit.gl.sketch in javascript (max 6, without jit.world)
*/
outlets = 2;

var N = 64 ;


// create jit.gl.sketch object and initialize it
var glsketch = new JitterObject("jit.gl.sketch","ribbons-ctx");



// create jit.phys.multiple object 
var JPM_1 = new JitterObject("jit.phys.multiple");
JPM_1.worldname = "fil-world" ;
JPM_1.name = "mult2" ;
JPM_1.constraint = "6dof" ;
JPM_1.filters = ["pick", "boule"] ;
JPM_1.sendconstraint(["strength", 1.]);

// create left anchor point
 var anchors_left = new JitterObject("jit.phys.6dof");
 anchors_left.worldname = "fil-world" ;
 anchors_left.body1 = "mult2_0" ;
 anchors_left.position2 = [-8, 0, 0,]; 
 
 // create right anchor point
 var anchors_right = new JitterObject("jit.phys.6dof");
 anchors_right.worldname = "fil-world" ;
 anchors_right.body1 = "mult2_63" ;
 anchors_right.position2 = [8, 0, 0,]; 


 

// initial position matrix for jit.phys.multiple 
var init_matrix = new JitterMatrix(3, "float32", N); //empty matrix
var jexpr_1 = new JitterObject("jit.expr"); // a jit.expr object
jexpr_1.expr = ["snorm[0]*8", 0,  0] ; // expression is ["snorm[0]*8", 0,  0] 
var first_pos_matrix = new JitterMatrix(3, "float32", N); // matrix to store the result from jit.expr
jexpr_1.matrixcalc(init_matrix, first_pos_matrix); // calculation

// initial scale matrix for jit.phys.multiple
var scale_matrix = new JitterMatrix(3, "float32", 1);
scale_matrix.setall(0.3);

var JPM_1_position_matrix_OUT = new JitterMatrix(3, "float32", N); //will receive output matrix from jit.phys.multiple


// apply initial position and scale matrix to jit.phys.multiple and get its output
JPM_1.scale_matrix(scale_matrix.name);
JPM_1.position_matrix(first_pos_matrix.name);
JPM_1_position_matrix_OUT.name = JPM_1.posoutname;


function bang() 
{
	//coordinates of points of our "string" ;
	var string_coords = new Array();
	
	for(var i = 0; i < N; i++) 
		{	
			//initialize sketch at the first "point"
			if(i==0) {
				glsketch.endstroke();
				glsketch_begin();
			} 
		
			string_coords = JPM_1_position_matrix_OUT.getcell(i);
			//glsketch.strokeparam("texture", nom1);
			glsketch.strokepoint(string_coords);
			//outlet(0, "position", coords);
			//outlet(1, "jit_matrix", JPM_1.posoutname);
			
		}
}


function glsketch_begin()
{
	glsketch.reset();
	glsketch.blend_enable = 1;
	glsketch.smooth_shading = 1;
	glsketch.glenable("line_smooth");
	glsketch.beginstroke("basic2d");
	glsketch.strokeparam("order", 3);
	glsketch.strokeparam("slices", 20);
	glsketch.strokeparam("scale", 0.1);
	glsketch.strokeparam("color", [1., 1., 1., 1.]);
}
	
	
//remove anchors_right
function remove_right_anchor() { anchors_right.freepeer(); }